<?php
/**** Global onstants and file includes ****/
include("constants.php");
include("connectdb.php");
include("security.php");
include("toolbar.php");
include("date_functions.php");

define(_THISFILE, "manage_trips.php");
$scookie = $_COOKIE[_COOKIE_NAME];

if(connect_db()){
	/****
	We have successfully logged on to the database.  Now we check the user's
	login cookie to make sure they should indeed be here.
	****/
	if(check_login_cookie($scookie, $_SERVER["REMOTE_ADDR"])){
		/*** all looks good.  grab the user ID and touch the cookie. ***/
		$uid = get_id_from_cookie($scookie);
		setcookie(_COOKIE_NAME, $scookie, touch_login_cookie($uid));

		/*** now check to see if this user actually has permission to
		make use of this page.  If not, send them to the main menu. ***/
		$query = "SELECT permissions FROM users WHERE user_id=".$uid;
		$data = mysql_fetch_array(mysql_query($query));
		if($data["permissions"] & (_MANAGE_OWN_TRIPS | _MANAGE_ALL_TRIPS)){
			/*** permissions check out.  draw the web page ***/
			draw_header();
			old_draw_body($uid);
			draw_toolbar($uid);
			draw_footer();
		}else{
			redirect("the login page", "index.php");
		}
	}else{
		redirect("the login page", "index.php");
	}
}else{
?>
	<h1>Unable to connect to database</h1>
	<p>An error occurred while trying to connect to the database.</p>
<?php
}

function draw_header(){
?>	<!DOCTYPE html PUBLIC "-//W3C//DTD html 4.0 Transitional//EN">
	<html>
	<head>
		<meta name="copyright" content="Copyright 2005, Jacob A. Ewing">
		<title>Trip Data</title>
		<link rel=stylesheet href="presentation.css" type="text/css">
	</head>
	<body>
		<h1>Trip Data</h1>
<?php
}

function draw_body($user_id){
	/** check to see if this user is allowed to modify other's trips **/
	$query = "SELECT permissions FROM users WHERE user_id=".$user_id;
	$data = mysql_fetch_array(mysql_query($query));
	if(($data["permissions"] & _MANAGE_ALL_TRIPS)){
		$show_all_trips = ($_POST["showall"] == 1);
		$can_see_all = TRUE;
	}else{
		/** not actually necessary, but just in case **/
		$show_all_trips = FALSE;
		$can_see_all = FALSE;
	}

?>	<hr>
	<form method=post action="<?echo _THISFILE?>">
<?php		if($can_see_all){
			if($show_all_tripss){
?>				<input type=submit name="IE_Sucks.html" value="Show only my trips"><br>
				<input type=hidden name="showall" value="0">
<?php			}else{
?>				<input type=submit name="IE_Sucks.html" value="Show all trips"><br>
				<input type=hidden name="showall" value="1">
<?php			}
		}
?>	</form>



	<table width="100%">
	<tr><td class=form_table width="30%">
<?php		draw_data_toolbar($user_id);
?>	</td><td class=form_table>
<?php		switch($_POST["action"]){
			case "Add Trip Data":
				draw_add_ride_form($user_id);
				break;
			case "Search Trip Data":
				echo "<p>No search form available yet.</p>\n";
				break;
			default:
				/** draw the default content **/
?>				<p>This paragraph is currently just space filler.  It
				should eventually be a basic welcoming with some rudimentary
				instructions on how to use this form</p>
<?php		}
?>	</td></tr>
	</table>
<?php
}

function draw_data_toolbar($user_id){
	echo "<form method=post action="._THISFILE.">\n";
?>	<table>
		<tr><td><input type=submit name="action" value="Add Trip Data"></td></tr>
		<tr><td><input type=submit name="action" value="Search Trip Data"></td></tr>
		<tr>
			<td>This should be a table for graphing data</td>
		</tr>
	</table>
<?php	echo "</form>\n";
}

function old_draw_body($user_id){
	/** check to see if this user is allowed to modify other's trips **/
	$query = "SELECT permissions FROM users WHERE user_id=".$user_id;
	$data = mysql_fetch_array(mysql_query($query));
	if(($data["permissions"] & _MANAGE_ALL_TRIPS)){
		$show_all_trips = ($_POST["showall"] == 1);
		$can_see_all = TRUE;
	}else{
		/** not actually necessary, but just in case **/
		$show_all_tripss = FALSE;
		$can_see_all = FALSE;
	}
?>	<hr>
	<form method=post action="<?echo _THISFILE?>">
<?php		if($can_see_all){
			if($show_all_tripss){
?>				<input type=submit name="IE_Sucks.html" value="Show only my trips"><br>
				<input type=hidden name="showall" value="0">
<?php			}else{
?>				<input type=submit name="IE_Sucks.html" value="Show all trips"><br>
				<input type=hidden name="showall" value="1">
<?php			}
		}
?>	</form>
	<table width="100%">
	<tr><td class=form_table>
<?		draw_list_table($user_id, $showall);
?>	</td><td class=form_table>
<?php		switch($_POST["action"]){
			case "Add":
				draw_add_ride_form($user_id);
				break;
			case "Modify":
				break;
			case "View":
				draw_view_ride_form($user_id);
				break;
			case "submit_ride":
				submit_ride_data($user_id);
				break;
			default:
				/** draw the default content **/
?>				<p>This paragraph is currently just space filler.  It
				should eventually be a basic welcoming with some rudimentary
				instructions on how to use this form</p>
<?php		}
?>	</td></tr>
	<tr><td class=form_table colspan=2>
		<h2>Search Trip Data</h2>
		<form method=post action="<?echo _THISFILE?>">
		<table>
			<!-- trip_date, distance, time_spent, peak_speed, vehicle, user_id -->
			<tr><td>Vehicle Name:</td><td><input type=text name="vehicle_name"></td></tr>
			<tr><td>Description:</td><td><input type=text name="vehicle_description"></td></tr>
<?php			if($can_see_all){
				echo "<tr><td>Owner Name:</td><td><input type=text name=\"vehicle_owner\"></td></tr>\n";
				$search_range = $_POST["search_range"];
				echo "<tr>\n<td><input type=radio name=search_range value=\"all\"";
				if($search_range != "mine") echo " checked";
				echo ">Search all vehicles</input></td>\n";
				echo "<td><input type=radio name=search_range value=\"mine\"";
				if($search_range == "mine") echo " checked";
				echo ">Search my vehicles</input></td>\n</tr>\n";
			}
?>			<tr><td colspan=2><input type=submit name="action" value="Search">
		</table>
<?php		if($_POST["showall"] == 1) echo"<input type=hidden name=\"showall\" value=\"1\">";
?>		</form>
	</td></tr>
	</table>
<?php
}

function draw_footer(){
	echo"</body>\n</html>\n";
}

function draw_list_table($user_id, $show_all_trips = 0){
?>	<h2>Trips</h2>
	<form method=post action="<?echo _THISFILE?>">
	<table>
		<tr><td>
			<select size=16 name="trip_number[]" multiple>
<?php				$query = "SELECT trip_number, trip_date, distance FROM trips";
				if(!$show_all_trips){
					$query .= " WHERE user_id=".$user_id;
				}
				$query .= " ORDER BY trip_date";
				$data = mysql_query($query);
				while($row = mysql_fetch_array($data)){
					echo "<option value=\"".$row["trip_number"]."\">";
					echo $row["trip_date"].": ".($row["distance"] / 1000)."km</option>\n";
				}
?>			</select><br>
		</td><td>
			<table>
			<tr><td><input type=submit name="action" value="View"></td></tr>
			<tr><td><input type=submit name="action" value="Modify"></td></tr>
			<tr><td><input type=submit name="action" value="Remove"></td></tr>
			<tr><td><input type=submit name="action" value="Add"></td></tr>
			</table>
		</td></tr>
	</table>
<?php	if($show_all_trips) echo"<input type=hidden name=\"showall\" value=\"1\">";
?>	</form>
<?php
}

/**** Do error checking on submitted ride data and enter it into the database. ****/
function submit_ride_data($user_id){
	/** First, grab the posted data **/
	$year = $_POST["ride_year"];
	$month = $_POST["ride_month"];
	$day = $_POST["ride_day"];
	$vehicle = $_POST["ride_vehicle"];
	$distance = $_POST["ride_distance"];
	$distance_unit = $_POST["ride_distance_unit"];
	$hours = $_POST["ride_time_hours"];
	$minutes = $_POST["ride_time_minutes"];
	$seconds = $_POST["ride_time_seconds"];
	$peak_speed = $_POST["ride_peak"];
	$peak_distance_unit = $_POST["peak_distance_unit"];
	$peak_time_unit = $_POST["peak_time_unit"];

	/**** check for errors and format the data.  All fields are allowed to be NULL ****/
	// Put the date in the correct format
	$datestring = sprintf("%04d-%02d-%02d", $year, $month, $day);

	// convert our distance to meters
	$query = "SELECT metre_value FROM distance_units WHERE name=\"".$distance_unit."\"";
	$data = mysql_fetch_array(mysql_query($query));
	$ratio = (float)$data["metre_value"];
	$metredistance = $distance * $ratio;

	// convert the peak speed to m/s
	$query = "SELECT metre_value FROM distance_units WHERE name=\"".$peak_distance_unit."\"";
	$data = mysql_fetch_array(mysql_query($query));
	$mv = $data["metre_value"];
	$query = "SELECT second_value FROM time_units WHERE name=\"".$peak_time_unit."\"";
	$data = mysql_fetch_array(mysql_query($query));
	$sv = $data["second_value"];
	$peakspeeddata = $peak_speed * $mv / $sv;

	// convert the time to seconds 
	$time_spent = 3600 * $hours + 60 * $minutes + $seconds;

	/**** build our query that submits the data ****/
	$query = "INSERT INTO trips (trip_date, distance, time_spent, peak_speed, vehicle, user_id) VALUES (";
	$query .= "\"".$datestring."\", ";
	$query .= $metredistance.", ";
	$query .= $time_spent.", ";
	$query .= $peakspeeddata.", ";
	$query .= $vehicle.", ";
	$query .= $user_id.")";

	/** and submit it to the database **/
	if(mysql_query($query) != FALSE){
		echo "<h4>Record added successfully</h4>";
	}

}

/*** Draw a quick form for users to enter ride data. ***/
function draw_add_ride_form($user_id){
	/*** draw a basic form for the user to insert ride data ***/
?>
	<h2>Trip Data</h2>
	<form method=post action="<?echo _THISFILE?>">
	<table>
		<tr>
			<td>Date:</td>
			<td><?draw_date_selection("ride_year", "ride_month", "ride_day", 0);?></td>
		</tr><tr>
			<td>Vehicle:</td>
			<td><?draw_vehicle_selection("ride_vehicle", $user_id);?></td>
		</tr><tr>
			<td>Distance:</td>
			<td><?draw_distance_selection("ride_distance", "ride_distance_unit");?></td>
		</tr><tr>
			<td>Time: (HH:MM:SS)</td>
			<td><?draw_time_selection("ride_time");?></td>
		</tr><tr>
			<td>Peak Speed:</td>
			<td><?draw_speed_selection("ride_peak", "peak_distance_unit", "peak_time_unit");?></td>
		</tr>
	</table>
	<input type=hidden name="action" value="submit_ride">
	<input type=submit name="IE_Sucks.html" value="Submit">
	</form>
<?php
}

function draw_vehicle_selection($varname, $user_id){
	$data = mysql_fetch_array(mysql_query("SELECT count(*) FROM vehicles WHERE user_id=".$user_id));
	$numvehicles = $data["count(*)"];
	if($numvehicles > 0){
		$data = mysql_query("SELECT vehicle_number, name FROM vehicles WHERE user_id=".$user_id);

?>		<select name="<?echo $varname?>">
<?			while($row = mysql_fetch_array($data)){
				echo "<option value=\"".$row["vehicle_number"]."\">";
				echo $row["name"]."</option>\n";
			}
?>		</select>
<?php	}else{
		echo "No Vehicles Defined";
	}
}

function draw_distance_selection($varname, $unitvarname){
	$data = mysql_fetch_array(mysql_query("SELECT count(*) FROM distance_units"));
	$numunits = $data["count(*)"];
	if($numunits > 0){
		echo "<input type=text size=6 name=\"".$varname."\">";
		/** Add a field to choose a unit of measurement **/
		$query = mysql_query("SELECT name, plural FROM distance_units");
		echo "<select name=\"".$unitvarname."\">\n";
		while($row = mysql_fetch_array($query)){
			echo "<option";
			if($row["name"] == _DEFAULT_DISTANCE_UNIT){
				echo " selected";
			}
			echo " value=\"".$row["name"]."\">";
			echo $row["plural"]."</option>\n";
		}
		echo "</select>\n";
	}else{
		echo "No Units Defined";
	}
}

function draw_time_selection($varname){
?>
	<input type=text size=2 name="<?echo $varname."_hours"?>"> :
	<input type=text size=2 name="<?echo $varname."_minutes"?>"> :
	<input type=text size=2 name="<?echo $varname."_seconds"?>">
<?php
}

function draw_speed_selection($varname, $distance_var, $time_var){
	$data = mysql_fetch_array(mysql_query("SELECT count(*) FROM distance_units"));
	$numdistunits = $data["count(*)"];
	$data = mysql_fetch_array(mysql_query("SELECT count(*) FROM time_units"));
	$numtimeunits = $data["count(*)"];
	if($numdistunits > 0 && $numtimeunits > 0){
		echo "<input type=text size=6 name=\"".$varname."\">";

		/** Add a field to choose a unit of distance measurement **/
		$query = mysql_query("SELECT name, plural FROM distance_units");
		echo "<select name=\"".$distance_var."\">\n";
		while($row = mysql_fetch_array($query)){
			echo "<option";
			if($row["name"] == _DEFAULT_DISTANCE_UNIT){
				echo " selected";
			}
			echo " value=\"".$row["name"]."\">";
			echo $row["plural"]."</option>\n";
		}
		echo "</select> per\n";

		/** Add a field to choose a unit of time measurement **/
		$query = mysql_query("SELECT name FROM time_units");
		echo "<select name=\"".$time_var."\">\n";
		while($row = mysql_fetch_array($query)){
			echo "<option";
			if($row["name"] == _DEFAULT_TIME_UNIT){
				echo " selected";
			}
			echo " value=\"".$row["name"]."\">";
			echo $row["name"]."</option>\n";
		}
		echo "</select>\n";
	}else{
		if(!$numtimeunits) echo "No Time Units Defined ";
		if(!$numdistunits) echo "No Distance Units Defined ";
	}
}

function draw_view_ride_form($user_id){
	/*** draw a basic from with which the ride data can be viewd ***/
?>	<table class=data_table rules="all">
		<thead class=datahead>
			<tr>
				<td>Date:</td>
				<td>Vehicle:</td>
				<td>Distance:</td>
				<td>Time:</td>
				<td>Average Speed:</td>
				<td>Peak Speed:</td>
			</tr>
		</thead>
<?php
	for($current_trip = 0; $current_trip < sizeof($_POST["trip_number"]); $current_trip++){
		$tripnum = $_POST["trip_number"][$current_trip];
		if($tripnum != ""){
			/*** Get the data about the trip ***/
			$query = "SELECT * FROM trips WHERE";
			if(!$show_all_trips){
				$query .= " user_id=".$user_id." AND";
			}
			$query .= " trip_number=".$tripnum;
			
			$trip_data = mysql_fetch_array(mysql_query($query));

			/*** get data about the vehicle ***/
			$query = "SELECT * FROM vehicles WHERE vehicle_number=".$trip_data["vehicle"];
			$vehicle_data = mysql_fetch_array(mysql_query($query));

			/*** simplify the HTML ahead by doing a couple of calculations first ***/
			if($trip_data["distance"] && $trip_data["time_spent"]){
				$average_speed = (int)(360 * $trip_data["distance"] / $trip_data["time_spent"]);
				$average_speed /= 100;
				$average_speed .= "km/h";
			}else{
				$average_speed = "Unknown";
			}

			$peak_speed = round($trip_data["peak_speed"] * 3.6, 2);
			if($peak_speed){
				$peak_speed .= "km/h";
			}else{
				$peak_speed = "Unknown";
			}

			$seconds = $trip_data["time_spent"];
			$displaytime = (int)($seconds / 3600);
			$seconds %= 3600;
			$displaytime .= ":".(int)($seconds / 60);
			$seconds %= 60;
			$displaytime .= ":".$seconds;

		

?>
			<tr>
				<td><?echo $trip_data["trip_date"];?></td>
				<td><?echo $vehicle_data["name"];?></td>
				<td><?echo $trip_data["distance"] / 1000;?> km</td>
				<td><?echo $displaytime;?></td>
				<td><?echo $average_speed?></td>
				<td><?echo $peak_speed;?></td>
			</tr>
<?php		}
	}
	echo "\t</table>\n";
}

?>
