<?
/**** Global onstants and file includes ****/
include("connectdb.php");
include("constants.php");
include("security.php");
include("toolbar.php");
define(_THISFILE, "manage_vehicles.php");
$scookie = $_COOKIE[_COOKIE_NAME];

if(connect_db()){
	/****
	We have successfully logged on to the database.  Now we check the user's
	login cookie to make sure they should indeed be here.
	****/
	if(check_login_cookie($scookie, $_SERVER["REMOTE_ADDR"])){
		/*** all looks good.  grab the user ID and touch the cookie. ***/
		$uid = get_id_from_cookie($scookie);
		setcookie(_COOKIE_NAME, $scookie, touch_login_cookie($uid));

		/*** now check to see if this user actually has permission to
		make use of this page.  If not, send them to the main menu. ***/
		$query = "SELECT permissions FROM users WHERE user_id=".$uid;
		$data = mysql_fetch_array(mysql_query($query));
		if($data["permissions"] & (_MANAGE_OWN_VEHICLES | _MANAGE_ALL_VEHICLES)){
			/*** permissions check out.  draw the web page ***/
			draw_header();
			switch($_POST["action"]){
				case "use_results":
					echo "\n<table><tr><td>\n";
					search_vehicles($uid);
					echo "\n</td><td>\n";
					switch($_POST["searchaction"]){
						case "View": view_vehicle($uid); break;
						case "Modify": modify_vehicle($uid); break;
						case "Remove": remove_vehicle($uid); break;
					}
					echo "\n</td></tr></table>\n";
					break;
				case "Search": search_vehicles($uid); break;
				case "View": view_vehicle($uid); break;
				case "Modify": modify_vehicle($uid); break;
				case "Update": update_vehicle($uid); break;
				case "Remove": remove_vehicle($uid); break;
				case "Add Vehicle": add_vehicle($uid); break;
			}
			draw_default_form($uid);
			draw_toolbar($uid);
			draw_footer();
		}else{
			redirect("the login page", "index.php");
		}
	}else{
		redirect("the login page", "index.php");
	}
}else{
?>
	<h1>Unable to connect to database</h1>
	<p>An error occurred while trying to connect to the database.</p>
<?
}

function draw_header(){
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD html 4.0 Transitional//EN">
<html>
<head>
	<meta name="copyright" content="Copyright 2005, Jacob A. Ewing">
	<title>Vehicle Management</title>
	<link rel=stylesheet href="presentation.css" type="text/css">
</head>
<body>
	<h1>Vehicle Management</h1>
<?
}

function draw_footer(){
	echo"</body>\n</html>\n";
}

function draw_default_form($user_id){
	/** check to see if this user is allowed to modify other's vehicles **/
	$query = "SELECT permissions FROM users WHERE user_id=".$user_id;
	$data = mysql_fetch_array(mysql_query($query));
	if(($data["permissions"] & _MANAGE_ALL_VEHICLES)){
		$show_all_vehicles = ($_POST["showall"] == 1);
		$can_see_all = TRUE;
	}else{
		/** not actually necessary, but just in case **/
		$show_all_vehicles = FALSE;
		$can_see_all = FALSE;
	}
?>
	<hr>

	<form method=post action="<?echo _THISFILE?>">
	<?if($can_see_all){
		if($show_all_vehicles){
			?>
			<input type=submit name="IE_Sucks.html" value="Show only my vehicles"><br>
			<input type=hidden name="showall" value="0">
			<?
		}else{
			?>
			<input type=submit name="IE_Sucks.html" value="Show all vehicles"><br>
			<input type=hidden name="showall" value="1">
			<?
		}
	}
	?>
	</form>

	<table>
	<tr><td class=form_table>
		<h2>Vehicles</h2>
		<form method=post action="<?echo _THISFILE?>">
		<table>
		<tr><td>
			<select size=16 name="vehicle_number">
<?
			$query = "SELECT vehicle_number, name, description FROM vehicles";
			if(!$show_all_vehicles){
				$query .= " WHERE user_id=".$user_id;
			}
			$data = mysql_query($query);
			while($row = mysql_fetch_array($data)){
				echo "<option value=\"".$row["vehicle_number"]."\">";
				echo $row["vehicle_number"].": \"".$row["name"]."\"";
				echo "</option>\n";
			}
?>
			</select><br>
		</td><td>
			<table>
			<tr><td><input type=submit name="action" value="View"></td></tr>
			<tr><td><input type=submit name="action" value="Modify"></td></tr>
			<tr><td><input type=submit name="action" value="Remove"></td></tr>
			</table>
		</td></tr>
		</table>
		<?if($show_all_vehicles) echo"<input type=hidden name=\"showall\" value=\"1\">";?>
		</form>
	</td><td class=form_table>
		<h2>Add A Vehicle</h2>
		<form method=post action="<?echo _THISFILE?>">
		<table>
			<tr><td>Vehicle Name:</td><td><input type=text name="vehicle_name"></td></tr>
			<tr><td>Description:</td><td><textarea name="vehicle_description" rows=8 cols=40></textarea></td></tr>
			<tr><td></td><td><input type=submit name="action" value="Add Vehicle">
		</table>
		<?if($show_all_vehicles) echo"<input type=hidden name=\"showall\" value=\"1\">";?>
		</form>
	</td><td class=form_table>
		<h2>Find A Vehicle</h2>
		<form method=post action="<?echo _THISFILE?>">
		<table>
			<tr><td>Vehicle Name:</td><td><input type=text name="vehicle_name"></td></tr>
			<tr><td>Description:</td><td><input type=text name="vehicle_description"></td></tr>
<?			if($can_see_all){
				echo "<tr><td>Owner Name:</td><td><input type=text name=\"vehicle_owner\"></td></tr>\n";

				$search_range = $_POST["search_range"];
				echo "<tr>\n<td><input type=radio name=search_range value=\"all\"";
				if($search_range != "mine") echo " checked";
				echo ">Search all vehicles</input></td>\n";
				echo "<td><input type=radio name=search_range value=\"mine\"";
				if($search_range == "mine") echo " checked";
				echo ">Search my vehicles</input></td>\n</tr>\n";
			}?>
			<tr><td colspan=2><input type=submit name="action" value="Search">
		</table>
		<?if($_POST["showall"] == 1) echo"<input type=hidden name=\"showall\" value=\"1\">";?>
		</form>
	</td></tr>
	</table>
<?
}

function add_vehicle($user_id){
	$vehicle_name = $_POST["vehicle_name"];
	$vehicle_description = $_POST["vehicle_description"];

	/*** Error check is done - no errors found.  Go ahead and insert the data. ***/
	$query = "INSERT INTO vehicles (user_id, name, description) VALUES(";
	$query .= $user_id.", ";
	$query .= "\"".$vehicle_name."\", ";
	$query .= "\"".$vehicle_description."\")";
	$success = mysql_query($query) or die("<h1>Error inserting data</h1>\n");
	if($success){
		echo "<p>Vehicle successfully added.</p>\n";
	}else{
		echo "<p>Unable to insert data.  Please contact the system administrator.\n";
	}
}

function remove_vehicle($user_id){
	$go_ahead = FALSE;
	$vehicle_number = $_POST["vehicle_number"];

	$query = "SELECT permissions FROM users WHERE user_id=".$user_id;
	$data = mysql_fetch_array(mysql_query($query));
	if($data["permissions"] & _MANAGE_ALL_VEHICLES){
		$go_ahead = TRUE;
	}else if($data["permissions"] & _MANAGE_OWN_VEHICLES){
		$query = "SELECT user_id FROM vehicles WHERE vehicle_number=".$vehicle_number;
		$data = mysql_fetch_array(mysql_query($query));
		if($data["user_id"] == $user_id)
			$go_ahead = TRUE;
	}
	if(!$vehicle_number) $go_ahead = FALSE;

	if($go_ahead){
		$query = "DELETE FROM vehicles WHERE vehicle_number=".$vehicle_number;
		$success = mysql_query($query) or die("<h1>Error removing vehicle</h1>\n");
		if($success){
			?><hr><p>Vehicle successfully deleted</p><?
		}else{
			?><p>There was an error while trying to delete the vehicle.
			Please contact the system administrator.</p><?
		}
	}
}

function view_vehicle($user_id){
	$go_ahead = TRUE;
	$vehicle_number = $_POST["vehicle_number"];

	$query = "SELECT permissions FROM users WHERE user_id=".$user_id;
	$data = mysql_fetch_array(mysql_query($query));
	if(!$data["permissions"] & _MANAGE_ALL_VEHICLES){
		if($data["permissions"] & _MANAGE_OWN_VEHICLES){
			$query = "SELECT user_id FROM vehicles WHERE vehicle_number=".$vehicle_number;
			$data = mysql_fetch_array(mysql_query($query));
			if($data["user_id"] != $user_id)
				$go_ahead = FALSE;
		}else{
			$go_ahead = FALSE;
		}
	}
	
	if(!$vehicle_number) $go_ahead = FALSE;

	if($go_ahead){
		$query = "SELECT * FROM vehicles WHERE vehicle_number=".$vehicle_number;
		$data = mysql_fetch_array(mysql_query($query));
		$vehicle_name = $data["name"];
		$vehicle_description = $data["description"];
		$vehicle_owner = $data["user_id"];

?>
		<form method=post action="<?echo _THISFILE?>">
		<table class=form_table>
			<tr><td><strong>Vehicle Number:</strong></td><td><?echo $vehicle_number;?></td></tr>
			<tr><td><strong>Vehicle Name:</strong></td><td><?echo $vehicle_name;?></td></tr>
			<tr><td><strong>Description:</strong></td><td><?echo $vehicle_description;?></td></tr>
			<tr>
			<td><input type=submit name="action" value="Modify"></td>
			<td><input type=submit name="action" value="Remove"></td>
			</tr>
		</table>
		<input type=hidden name="vehicle_number" value=<?echo $vehicle_number?>>
		<?
		if($_POST["showall"] == 1) echo"<input type=hidden name=\"showall\" value=\"1\">";
		?>
		</form>
<?
	}
}

function modify_vehicle($user_id){
	$go_ahead = TRUE;
	$view_ownership = FALSE;
	$vehicle_number = $_POST["vehicle_number"];

	$query = "SELECT permissions FROM users WHERE user_id=".$user_id;
	$data = mysql_fetch_array(mysql_query($query));
	if($data["permissions"] & _MANAGE_ALL_VEHICLES){
		$view_ownership = TRUE;
	}else if($data["permissions"] & _MANAGE_OWN_VEHICLES){
		$query = "SELECT user_id FROM vehicles WHERE vehicle_number=".$vehicle_number;
		$data = mysql_fetch_array(mysql_query($query));
		if($data["user_id"] != $user_id)
			$go_ahead = FALSE;
	}else{
		$go_ahead = FALSE;
	}
	if($vehicle_number == "") $go_ahead = FALSE;

	if($go_ahead){
		$query = mysql_query("SELECT * FROM vehicles WHERE vehicle_number=".$vehicle_number);
		$data = mysql_fetch_array($query);
		$vehicle_name = $data["name"];
		$vehicle_description = $data["description"];
		if($view_ownership){
			$vehicle_owner = $data["user_id"];
			$data = mysql_fetch_array(mysql_query("SELECT name FROM users WHERE user_id=".$vehicle_owner));
			$owner_name = $data["name"];
		}
?>
		<form method=post action="<?echo _THISFILE?>">
		<table class=form_table>
			<tr><td><strong>Vehicle Number:</strong></td><td><?echo $vehicle_number;?></td></tr>
			<?if($view_ownership)
				echo "<tr><td><strong>Owner:</strong></td><td>[".$vehicle_owner."] ".$owner_name."</td></tr>";
			?>
			<tr>
				<td><strong>Vehicle Name:</strong></td>
				<td><input type=text name="vehicle_name" value="<?echo $vehicle_name;?>"></td>
			</tr>
			<tr>
				<td><strong>Description:</strong></td>
				<td><textarea name="vehicle_description" rows=8 cols=40><?echo $vehicle_description;?></textarea></td>
			</tr>
			<tr>
			<td></td><td><input type=submit name="action" value="Update"></td>
			</tr>
		</table>
		<?if($_POST["showall"] == 1) echo"<input type=hidden name=\"showall\" value=\"1\">";?>
		<input type=hidden name="vehicle_number" value="<?echo $vehicle_number?>">
		</form>
<?
	}
}

function update_vehicle($user_id){
	$go_ahead = FALSE;
	$vehicle_number = $_POST["vehicle_number"];

	$query = "SELECT permissions FROM users WHERE user_id=".$user_id;
	$data = mysql_fetch_array(mysql_query($query));
	if($data["permissions"] & _MANAGE_ALL_VEHICLES){
		$go_ahead = TRUE;
	}else if($data["permissions"] & _MANAGE_OWN_VEHICLES){
		$query = "SELECT user_id FROM vehicles WHERE vehicle_number=".$vehicle_number;
		$data = mysql_fetch_array(mysql_query($query));
		if($data["user_id"] == $user_id)
			$go_ahead = TRUE;
	}

	if($go_ahead){
		$vehicle_name = $_POST["vehicle_name"];
		$vehicle_description = $_POST["vehicle_description"];
		$query = "UPDATE vehicles SET ";
		$query .= "name=\"".$vehicle_name."\", ";
		$query .= "description=\"".$vehicle_description."\" ";
		$query .= "WHERE vehicle_number=".$vehicle_number;

		$success = mysql_query($query) or die("<h1>Error updating data</h1>\n");
		if($success){
			echo "<p>Vehicle successfully updated.</p>\n";
		}else{
			echo "<p>Unable to update vehicle.  Please contact the system administrator.\n";
		}
	}
}

function search_vehicles($user_id){
	$searchowner = $_POST["vehicle_owner"];
	$searchname = $_POST["vehicle_name"];
	$searchdescription = $_POST["vehicle_description"];
	$search_range = $_POST["search_range"];

	/*** replace the wildcards with ones used by MySQL ***/
	$searchowner = str_replace("*", "%", $searchowner);
	$searchowner = str_replace("?", "_", $searchowner);
	$searchname = str_replace("*", "%", $searchname);
	$searchname = str_replace("?", "_", $searchname);
	$searchdescription = str_replace("*", "%", $searchdescription);
	$searchdescription = str_replace("?", "_", $searchdescription);

	/*** make sure they have permission to do as requested ***/
	$allowed = FALSE;
	$showowner = FALSE;
	if($search_range == "all"){
		/** check for permission to search others' vehicles **/
		$data = mysql_fetch_array(mysql_query("SELECT permissions FROM users WHERE user_id=".$user_id));
		if($data["permissions"] & _MANAGE_ALL_VEHICLES){
			$allowed = TRUE;
			$showowner = TRUE;
		}
	}else{
		$search_range = "mine";
		$allowed = TRUE;
	}

	/*** build our query ***/
	if($allowed){
		$logic_gate = " WHERE ";
		$query = "SELECT users.name, vehicles.name AS vname, vehicles.vehicle_number";
		$query .= " FROM vehicles LEFT JOIN users ON vehicles.user_id=users.user_id";

		if($search_range == "mine"){
			$query .= $logic_gate."users.user_id=".$user_id;
			$logic_gate = " AND ";
		}else if($searchowner != ""){
			$query .= $logic_gate."users.name LIKE \"".$searchowner."\"";
			$logic_gate = " AND ";
		}

		if($searchdescription != ""){
			$query .= $logic_gate."vehicles.description LIKE \"".$searchdescription."\"";
			$logic_gate = " AND ";
		}

		if($searchname != ""){
			$query .= $logic_gate."vehicles.name LIKE \"".$searchname."\"";
		}
		$query .= " ORDER BY users.name";

		/**** The query had been compiled, now do it and display the results ****/
?>
		<form method=post action="<?echo _THISFILE?>">
		<table class=form_table>
		<tr><td colspan=2>
			<h2>Search Results</h2>
		</td></tr><tr><td>
			<select size=16 name="vehicle_number">
<?
			$data = mysql_query($query);
			while($row = mysql_fetch_array($data)){
				echo "<option value=\"".$row["vehicle_number"]."\">";
				echo "[".$row["vehicle_number"]."]: ";
				if($showowner){
					echo $row["name"].": ";
				}
				echo "\"".$row["vname"]."\"";
				echo "</option>\n";
			}
?>
			</select>
		</td><td>
			<table>
				<tr><td><input type=submit name="searchaction" value="View"></td></tr>
				<tr><td><input type=submit name="searchaction" value="Modify"></td></tr>
				<tr><td><input type=submit name="searchaction" value="Remove"></td></tr>
			</table>
		</td></tr>
		</table>
		<input type=hidden name="action" value="use_results">
		<input type=hidden name="vehicle_name" value="<?echo $_POST["vehicle_name"]?>">
		<input type=hidden name="vehicle_description" value="<?echo $_POST["vehicle_description"]?>">
		<input type=hidden name="vehicle_owner" value="<?echo $_POST["vehicle_owner"]?>">
		<input type=hidden name="search_range" value="<?echo $_POST["search_range"]?>">
		<?if($_POST["showall"] == 1) echo"<input type=hidden name=\"showall\" value=\"1\">";?>
		</form>
<?

	}else{
		echo "<p>You do not have permission to perform this search.</p>\n";
	}
}

function draw_search_form($query){
}

?>
