<?
/**** Global constants and file includes ****/
define(_THISFILE, "settings.php");//$_SERVER['PHP_SELF'];
include("constants.php");
include("connectdb.php");
include("security.php");
include("toolbar.php");
$scookie = $_COOKIE[_COOKIE_NAME];

if(connect_db()){
	/****
	We have successfully logged on to the database.  Now we check the user's
	login cookie to make sure they should indeed be here.
	****/
	if(check_login_cookie($scookie, $_SERVER["REMOTE_ADDR"])){
		/*** all looks good.  grab the user ID and touch the cookie. ***/
		$uid = get_id_from_cookie($scookie);
		setcookie(_COOKIE_NAME, $scookie, touch_login_cookie($uid));

		draw_header();
		if($_POST["action"] == "Update"){
			update_user_info($uid);
		}
		draw_default_form($uid);
		draw_toolbar($uid);
		draw_footer();
	}else{
		redirect("the login page", "index.php");
	}
}else{
	draw_header();
	echo "<h1>Unable to connect to database</h1>\n";
	echo "<p>An error occurred while trying to connect to the database.</p>\n";
	draw_footer();
}

function draw_header(){
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<meta name="copyright" content="Copyright 2005, Jacob A. Ewing">
	<title>Personal Settings</title>
	<link rel=stylesheet href="presentation.css" type="text/css">
</head>
<body>
<?php
}

function draw_footer(){
	echo "</body>\n</html>\n";
}

function draw_default_form($user_id){
	$name = $_POST["name"];
	$email = $_POST["email"];
	$question = $_POST["question"];
	$answer = $_POST["answer"];
	$query = "SELECT login, name, email, challenge_question, challenge_answer, preferences FROM users";
	$query .= " WHERE user_id=".$user_id;
	$data = mysql_fetch_array(mysql_query($query));
	$username = $data["login"];
	if($name == "") $name = $data["name"];
	if($email == "") $email = $data["email"];
	if($question == "") $question = $data["challenge_question"];
	if($answer == "") $answer = $data["challenge_answer"];
	$prefrenceflags = $data["preferences"];
	
?>	<h1>Personal Settings</h1>
	<form method=post action="<?echo _THISFILE?>">
	<table width="100%">
		<tr><td>
			<table class=form_table width="100%">
				<tr>
					<td>Username:</td>
					<td><?echo $username?></td>
				</tr><tr>
					<td>Password:</td>
					<td><input type=password name="password" size=40></td>
				</tr><tr>
					<td>Confirm Password:</td>
					<td><input type=password name="confirmpass" size=40></td>
				</tr><tr>
					<td>Real Name:</td>
					<td><input type=text name="name" size=40 value="<?echo $name?>"></td>
				</tr><tr>
					<td>e-mail Address:</td>
					<td><input type=text name="email" size=40 value="<?echo $email?>"></td>
				</tr><tr>
					<td>Challenge Question:</td>
					<td><input type=text name="question" size=40 value="<?echo $question?>"></td>
				</tr><tr>
					<td>Challenge Answer:</td>
					<td><input type=text name="answer" size=40 value="<?echo $answer?>"></td>
				</tr><tr>
					<td colspan=2><input type=submit name="action" value="Update"></td>
				</tr>
			</table>
		</td><td>
			<table class=form_table width="100%">
				<tr><td><input type=checkbox name="share_data" value="1"<?php
				if($prefrenceflags & _PREF_SHARE_DATA) echo " checked";?>>
				</td><td>Make statistics viewable to the public</td></tr>
			</table>
		</td></tr>
	</table>
	</form>
<?php
}

function update_user_info($user_id){
	$password = $_POST['password'];
	$confirmpass = $_POST['confirmpass'];
	$name = $_POST['name'];
	$email = $_POST['email'];
	$question = $_POST['question'];
	$answer = $_POST['answer'];
	$error = 0;
	$prefflags = 0;

	/*** make sure of the required fields were filled out.  Note that
	the password field won't be required here, so that the user can be
	modified without having to re-enter or decrypt the password.
	 ***/
	$formfilled = ($name != "");
	$formfilled &= ($email != "");
	$formfilled &= ($question != "");
	$formfilled &= ($answer != "");

	if(!$formfilled){ /** not all fields in the form were filled out **/
		$error |= 1;
	}

	/*** check the validity of the password, and make sure it matches the confirmed one ***/
	if(strcmp($password, $confirmpass)){
		$error |= 2;
	}else{
		$len = strlen($password);
		if(($len < 5 || $len > 32) && $len != 0)
			$error |= 4;
	}

	if($error){
		?><h3>Unable to modify user:</h3>
		<?
		/** at least one piece of the data submitted is invalid.  Give the user
		any pertinent error messages **/
		echo "<ul>\n";
		if($error & 1){
?>			<li>All fields in the form must be filled out</li>
<?php		}

		if($error & 2){
?>			<li>The "password" and "confirm password" fields do not match.  Please
			note that passwords are case-sensitive.</li>
<?php		}

		if($error & 4){
?>			<li>The password you choose must be between 5 and 32 characters.</li>
<?php		}
		echo "</ul>\n";

	}else{ /** all data submitted clears out.  Update the database **/
		/** collect the preference flags **/
		if($_POST["share_data"] == "1") $prefflags |= _PREF_SHARE_DATA;

		/** build the SQL command **/
		$query = "UPDATE users SET ";
		if($password != "")
			$query .= "password=encode(\"".$password."\", \"".$password."\"), ";
		$query .= "name=\"".$name."\", ";
		$query .= "email=\"".$email."\", ";
		$query .= "challenge_question=\"".$question."\", ";
		$query .= "challenge_answer=\"".$answer."\", ";
		$query .= "preferences=".$prefflags." ";
		$query .= "WHERE user_id=".$user_id;
		$success = mysql_query($query)
			or die("<h1>Error updating data</h1>\n<p>Unable to update user. Please contact the system administrator.</p>\n");
		if($success){
			echo "<p>Account successfully modified</p>\n";
		}
	}
}
